//
// filename : profiler.h
//
// Constants and enums for profiler.ulp.
//
// (Actually, they should be consts and typedefs,
// but Eagle doesn't support that.)
//
// erstellt von Gerd Vogel am 28.06.2007
//
// No users options here.
//

string RELEASE = "GV";
string REVISION = "2.00";
string DEFAULT_EXTENSION = ".col";
int FILENAMES_8_CHARACTERS = NO;

string PATH = path_ulp[0];
string TIEFE = "0.0";

enum { TASK_INVALID, TASK_OUTLINES, TASK_FILL };

enum { ST_INVALID,
       ST_START_LINE, ST_CONTINUE_LINE, ST_END_LINE,
       ST_DRILL,
       ST_FILL,
	   ST_ARC_BEGIN,
	   ST_ARC_END
     };

enum { TOP = 0, BOTTOM = 1, MILL = 2, ALL = 3 };

int PROGRAM_NAME_ARG = 0;
int FILENAME_ARG = 1;
int WIDTH_ARG = 2;
int ISO_ARG = 3;
int PASS_ARG = 4;
int PHASE_ARG = 5;

int fraeser_nr = 20;

real COORD_TOLERANCE = 0.0001;

string OUTLINES_SIGNAL_NAME = "_OUTLINES_";

int TOP_LAYER = 1;
int BOTTOM_LAYER = 16;
int MILL_LAYER = 46;

int OUTLINES   = 1;
int FILL       = 2;
int MILL_BOARD = 3;

enum {
  PH_INVALID		   =  0,
  PH_TOP_OUT_GEN       =  1,
  PH_TOP_OUT_WRITE     =  2,
  PH_TOP_FILL_GEN      =  3,
  PH_TOP_FILL_WRITE    =  4,
  PH_BOTTOM_OUT_GEN    =  5,
  PH_BOTTOM_OUT_WRITE  =  6,
  PH_BOTTOM_FILL_GEN   =  7,
  PH_BOTTOM_FILL_WRITE =  8,
  PH_TOP_DRILL         =  9,
  PH_BOTTOM_DRILL      = 10,
  PH_MILL              = 11,
  PH_LAST_PHASE        = 12
};

string PHASE_NAME[] = {
	"invalid",
	"Gen_Top_Outlines", "Write_Top_Outlines", 
	"Gen_Top_Fill", "Write_Top_Fill",
	"Gen_Bottom_Outlines", "Write_Bottom_Outlines", 
	"Gen_Bottom_Fill", "Write_Bottom_Fill",
	"Top_Drills", "Bottom_Drills", 
	"Milling", 
	"Finished!"
};

// Used to convert a numeric state into a text name for that state.
string state_text[] = {
  "ST_START_LINE",
  "ST_CONTINUE_LINE",
  "ST_END_LINE",
  "ST_DRILL",
  "ST_FILL"
};

real ROUND_FACTOR = 1000;

real BORDER_SIZE = 0.001;

int DRILL_SIZE = 0;
int DRILL_X = 1;
int DRILL_Y = 2;

string UNIT_OF_MEASURE = "not set";

real width = 0.01;
real ISOLATIONS_TIEFE;

int side = TOP;

// Which phase of the process we're working on.
int g_phase;

// I know, I know. No way around it that I see right now.
string g_real_to_string_string = "";

//-----------------------------------------------------------------------------
string real_to_string(real n)
{
	sprintf(g_real_to_string_string, "%f", n);
	return g_real_to_string_string;
}

string g_int_to_string_string = "";

//-----------------------------------------------------------------------------
string int_to_string(int n)
{
	sprintf(g_int_to_string_string, "%d", n);
	return g_int_to_string_string;
}

// berprfung der Einstellwerte ob die Werte das richtige Vorzeichen haben
//-----------------------------------------------------------------------------
void ueberpruefe_werte(void)
{
  if (MILLING_DEPTH < 0.0)      MILLING_DEPTH = MILLING_DEPTH * -1.0;
  if (DEFAULT_Z_HIGH > 0.0)     DEFAULT_Z_HIGH = DEFAULT_Z_HIGH * -1.0;
  if (DEFAULT_Z_UP > 0.0)       DEFAULT_Z_UP = DEFAULT_Z_UP * -1.0;
  if (SPINDLE_ON_TIME < 0.0)    SPINDLE_ON_TIME = SPINDLE_ON_TIME * -1.0;
  if (DEFAULT_WIDTH < 0.0)      DEFAULT_WIDTH = DEFAULT_WIDTH * -1.0;
  if (FEED_RATE < 0.0)          FEED_RATE = FEED_RATE * -1.0;
  if (FEED_RATE_FAST < 0.0)     FEED_RATE_FAST = FEED_RATE_FAST * -1.0;
  if (FEED_RATE_Z < 0.0)        FEED_RATE_Z = FEED_RATE_Z * -1.0;
  if (FEED_RATE_Z_FAST < 0.0)   FEED_RATE_Z_FAST = FEED_RATE_Z_FAST * -1.0;
  if (DRILL_DEPTH < 0.0)        DRILL_DEPTH = DRILL_DEPTH * -1.0;
  if (DRILL_DWELL < 0.0)        DRILL_DWELL = DRILL_DWELL * -1.0;
  if (MAX_DRILL < 0.0)          MAX_DRILL = MAX_DRILL * -1.0;
  if (DRILL_MILL_TOOL < 0.0)    DRILL_MILL_TOOL = DRILL_MILL_TOOL * -1.0;
  if (DEFAULT_ISOLATE < 0.0)    DEFAULT_ISOLATE = DEFAULT_ISOLATE * -1.0;
  if (ISO_MAX < 0.0)            ISO_MAX = ISO_MAX * -1.0;
  if (ISO_STEP < 0.0)           ISO_STEP = ISO_STEP * -1.0;
  if (ISOLATIONS_DEPTH < 0.0)   ISOLATIONS_DEPTH = ISOLATIONS_DEPTH * -1.0;
}

//------------------------- END OF FILE ---------------------------------------
