//
// filename : profiler_fileutils.h
//
// erstellt von Gerd Vogel am 28.06.2007
//

#include "profiler_pcb_defaults.h"
#include "profiler.h"

//-----------------------------------------------------------------------------
void output_file_heading()
{
string COMMENT_BEGIN = ";";
string COMMENT_END   = "";	

        printf("%s This file generated by %s %s\n"
		"%s Copyright 2007 by Gerd Vogel %s\n",
		COMMENT_BEGIN, argv[PROGRAM_NAME_ARG], COMMENT_END,
		COMMENT_BEGIN, COMMENT_END
		);
		
	if (NC_FILE_COMMENT_FROM_BOARD) {
		board(B) {
			printf("\n%s This file generated from the board %s %s\n", 
            COMMENT_BEGIN, B.name, COMMENT_END);
		}
	}
	
	if (NC_FILE_COMMENT_DATE) {
		printf("%s This file generated %s %s\n", 
        COMMENT_BEGIN, t2string(time()), COMMENT_END);
	}
	
	if (NC_FILE_COMMENT_MACHINE_SETTINGS) {
		printf("\n%s Settings : %s\n", 
        COMMENT_BEGIN, COMMENT_END);
		printf("%s tool size = %6.4f %s\n", 
        COMMENT_BEGIN, width, COMMENT_END);
		printf("%s z high = %6.4f\tz up = %6.4f\tz down = %6.4f %s\n", 
			COMMENT_BEGIN, DEFAULT_Z_HIGH, DEFAULT_Z_UP, MILLING_DEPTH, COMMENT_END);
		printf("%s drill depth = %6.4f %s\n", 
        COMMENT_BEGIN, DRILL_DEPTH, COMMENT_END);
		printf("%s spindle on time = %6.4f %s\n", 
        COMMENT_BEGIN, SPINDLE_ON_TIME, COMMENT_END);
		printf("%s milling depth = %6.4f %s\n", 	 
        COMMENT_BEGIN, MILLING_DEPTH, COMMENT_END);
		printf("%s feed rate = %6.4f\tfeed rate z = %6.4f %s\n", 
			COMMENT_BEGIN, FEED_RATE, FEED_RATE_Z, COMMENT_END);
	}

	if (NC_FILE_COMMENT_PCB_DEFAULTS_SETTINGS) {
		printf("\n%s Settings : %s\n", 
        COMMENT_BEGIN, COMMENT_END);
		printf("%s Default isolate = %6.4f %s\n", 
        COMMENT_BEGIN, DEFAULT_ISOLATE, COMMENT_END);
		printf("%s isolate max = %6.4f %s\n", 
        COMMENT_BEGIN, ISO_MAX, COMMENT_END);
		printf("%s isolate step = %6.4f %s\n", 
        COMMENT_BEGIN, ISO_STEP, COMMENT_END);
		printf("%s Generated: %s%s%s%s%s%s %s\n", 
        COMMENT_BEGIN,
			(GENERATE_TOP_OUTLINES) ? "top outlines, " : "",
			(GENERATE_TOP_DRILL) ? "top drill, " : "",
			(GENERATE_TOP_FILL) ? "top fill, " : "",
			(GENERATE_BOTTOM_OUTLINES) ? "bottom outlines, " : "",
			(GENERATE_BOTTOM_DRILL) ? "bottom drill, " : "",
			(GENERATE_BOTTOM_FILL) ? "bottom fill" : "",
			COMMENT_END);
		printf("%s Unit of measure: %s %s\n", 
        COMMENT_BEGIN, UNIT_OF_MEASURE, COMMENT_END);
		printf("\n");
	}
	
	printf("\n");
}

//-----------------------------------------------------------------------------
void output_between_outline_passes()
{
	
}

//
// Print file beginning headers and user-codes.
//
//-----------------------------------------------------------------------------
void output_file_preamble()
{
    printf("OF X:%5.0f, Y:%5.0f, Z:%5.0f;\n",SCALE_FAKTOR,SCALE_FAKTOR,SCALE_FAKTOR);
    printf("@ZU %.2f;\n",FEED_RATE_Z_FAST);
    printf("@ZD %.2f;\n",FEED_RATE_Z);
    printf("VS %.2f;\n",FEED_RATE_FAST);
}

//------------------------- END OF FILE ---------------------------------------
